from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class NssetInfoRequest(_message.Message):
    __slots__ = ("nsset_id", "nsset_history_id")
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    NSSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    nsset_id: _nsset_common_types_pb2.NssetId
    nsset_history_id: _nsset_common_types_pb2.NssetHistoryId
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset_history_id: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]] = ...) -> None: ...

class DnsHost(_message.Message):
    __slots__ = ("fqdn", "ip_addresses")
    FQDN_FIELD_NUMBER: _ClassVar[int]
    IP_ADDRESSES_FIELD_NUMBER: _ClassVar[int]
    fqdn: str
    ip_addresses: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, fqdn: _Optional[str] = ..., ip_addresses: _Optional[_Iterable[str]] = ...) -> None: ...

class TechnicalCheckLevel(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: int
    def __init__(self, value: _Optional[int] = ...) -> None: ...

class NssetInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("nsset_handle", "nsset_id", "nsset_history_id", "dns_hosts", "technical_contacts_old", "technical_contacts", "technical_check_level", "auth_info", "events", "sponsoring_registrar")
        NSSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
        NSSET_ID_FIELD_NUMBER: _ClassVar[int]
        NSSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        DNS_HOSTS_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_OLD_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CHECK_LEVEL_FIELD_NUMBER: _ClassVar[int]
        AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        nsset_handle: _nsset_common_types_pb2.NssetHandle
        nsset_id: _nsset_common_types_pb2.NssetId
        nsset_history_id: _nsset_common_types_pb2.NssetHistoryId
        dns_hosts: _containers.RepeatedCompositeFieldContainer[DnsHost]
        technical_contacts_old: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        technical_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactRef]
        technical_check_level: TechnicalCheckLevel
        auth_info: _common_types_pb2.AuthInfo
        events: _object_events_pb2.ObjectEvents
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        def __init__(self, nsset_handle: _Optional[_Union[_nsset_common_types_pb2.NssetHandle, _Mapping]] = ..., nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset_history_id: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]] = ..., dns_hosts: _Optional[_Iterable[_Union[DnsHost, _Mapping]]] = ..., technical_contacts_old: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., technical_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactRef, _Mapping]]] = ..., technical_check_level: _Optional[_Union[TechnicalCheckLevel, _Mapping]] = ..., auth_info: _Optional[_Union[_common_types_pb2.AuthInfo, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist",)
        class NssetDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: NssetInfoReply.Exception.NssetDoesNotExist
        def __init__(self, nsset_does_not_exist: _Optional[_Union[NssetInfoReply.Exception.NssetDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: NssetInfoReply.Data
    exception: NssetInfoReply.Exception
    def __init__(self, data: _Optional[_Union[NssetInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[NssetInfoReply.Exception, _Mapping]] = ...) -> None: ...

class NssetIdRequest(_message.Message):
    __slots__ = ("nsset_handle",)
    NSSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
    nsset_handle: _nsset_common_types_pb2.NssetHandle
    def __init__(self, nsset_handle: _Optional[_Union[_nsset_common_types_pb2.NssetHandle, _Mapping]] = ...) -> None: ...

class NssetIdReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("nsset_id", "nsset_history_id")
        NSSET_ID_FIELD_NUMBER: _ClassVar[int]
        NSSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        nsset_id: _nsset_common_types_pb2.NssetId
        nsset_history_id: _nsset_common_types_pb2.NssetHistoryId
        def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset_history_id: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist",)
        class NssetDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: NssetIdReply.Exception.NssetDoesNotExist
        def __init__(self, nsset_does_not_exist: _Optional[_Union[NssetIdReply.Exception.NssetDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: NssetIdReply.Data
    exception: NssetIdReply.Exception
    def __init__(self, data: _Optional[_Union[NssetIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[NssetIdReply.Exception, _Mapping]] = ...) -> None: ...

class CheckDnsHostRequest(_message.Message):
    __slots__ = ("fqdn",)
    FQDN_FIELD_NUMBER: _ClassVar[int]
    fqdn: str
    def __init__(self, fqdn: _Optional[str] = ...) -> None: ...

class CheckDnsHostReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("dns_host_exists",)
        DNS_HOST_EXISTS_FIELD_NUMBER: _ClassVar[int]
        dns_host_exists: bool
        def __init__(self, dns_host_exists: bool = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: CheckDnsHostReply.Data
    def __init__(self, data: _Optional[_Union[CheckDnsHostReply.Data, _Mapping]] = ...) -> None: ...
